#!/bin/bash

function do_help {
cat <<EOF
    Usage: build.sh <build|debug>
        build:     build the project.
        debug:     start a bash for debug
EOF
}

SCRIPTPATH=$(cd "$(dirname "$0")"; pwd)
cd ${SCRIPTPATH}/../..
echo $(pwd)

case $1 in
    build)
        shift
        cmake -S . -B ../build/debug -DCMAKE_BUILD_TYPE=Debug && \
        cmake -S . -B ../build/release -DCMAKE_BUILD_TYPE=RelWithDebInfo && \
        cmake --build ../build/debug  $@ &&\
        cmake --build ../build/release $@
        ;;
    debug)
        bash
        ;;
    *)
        do_help
        ;;
esac


